/*
 * Copyright 2010-2014 Ning, Inc.
 * Copyright 2014-2020 Groupon, Inc
 * Copyright 2020-2021 Equinix, Inc
 * Copyright 2014-2021 The Billing Project, LLC
 *
 * The Billing Project licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */


package org.killbill.billing.client.model.gen;

import java.util.Objects;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.List;

/**
 *           DO NOT EDIT !!!
 *
 * This code has been generated by the Kill Bill swagger generator.
 *  @See https://github.com/killbill/killbill-swagger-coden
 */
import org.killbill.billing.client.model.KillBillObject;

public class PriceList {

    private String name = null;

    private List<String> plans = null;


    public PriceList() {
    }

    public PriceList(final String name,
                     final List<String> plans) {
        this.name = name;
        this.plans = plans;

    }


    public PriceList setName(final String name) {
        this.name = name;
        return this;
    }

    public String getName() {
        return name;
    }

    public PriceList setPlans(final List<String> plans) {
        this.plans = plans;
        return this;
    }

    public PriceList addPlansItem(final String plansItem) {
        if (this.plans == null) {
            this.plans = new ArrayList<String>();
        }
        this.plans.add(plansItem);
        return this;
    }

    public List<String> getPlans() {
        return plans;
    }

    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        PriceList priceList = (PriceList) o;
        return Objects.equals(this.name, priceList.name) &&
            Objects.equals(this.plans, priceList.plans);
    }

    @Override
    public int hashCode() {
        return Objects.hash(name,
            plans);
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class PriceList {\n");
        
        sb.append("    name: ").append(toIndentedString(name)).append("\n");
        sb.append("    plans: ").append(toIndentedString(plans)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }
}

