/*
 * Copyright 2010-2014 Ning, Inc.
 * Copyright 2014-2020 Groupon, Inc
 * Copyright 2020-2021 Equinix, Inc
 * Copyright 2014-2021 The Billing Project, LLC
 *
 * The Billing Project licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */


package org.killbill.billing.client.model.gen;

import java.util.Objects;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.List;
import org.killbill.billing.client.model.gen.Limit;
import org.killbill.billing.client.model.gen.Price;
import org.killbill.billing.client.model.gen.TieredBlock;

/**
 *           DO NOT EDIT !!!
 *
 * This code has been generated by the Kill Bill swagger generator.
 *  @See https://github.com/killbill/killbill-swagger-coden
 */
import org.killbill.billing.client.model.KillBillObject;

public class Tier {

    private List<Limit> limits = null;

    private List<Price> fixedPrice = null;

    private List<Price> recurringPrice = null;

    private List<TieredBlock> blocks = null;


    public Tier() {
    }

    public Tier(final List<Limit> limits,
                     final List<Price> fixedPrice,
                     final List<Price> recurringPrice,
                     final List<TieredBlock> blocks) {
        this.limits = limits;
        this.fixedPrice = fixedPrice;
        this.recurringPrice = recurringPrice;
        this.blocks = blocks;

    }


    public Tier setLimits(final List<Limit> limits) {
        this.limits = limits;
        return this;
    }

    public Tier addLimitsItem(final Limit limitsItem) {
        if (this.limits == null) {
            this.limits = new ArrayList<Limit>();
        }
        this.limits.add(limitsItem);
        return this;
    }

    public List<Limit> getLimits() {
        return limits;
    }

    public Tier setFixedPrice(final List<Price> fixedPrice) {
        this.fixedPrice = fixedPrice;
        return this;
    }

    public Tier addFixedPriceItem(final Price fixedPriceItem) {
        if (this.fixedPrice == null) {
            this.fixedPrice = new ArrayList<Price>();
        }
        this.fixedPrice.add(fixedPriceItem);
        return this;
    }

    public List<Price> getFixedPrice() {
        return fixedPrice;
    }

    public Tier setRecurringPrice(final List<Price> recurringPrice) {
        this.recurringPrice = recurringPrice;
        return this;
    }

    public Tier addRecurringPriceItem(final Price recurringPriceItem) {
        if (this.recurringPrice == null) {
            this.recurringPrice = new ArrayList<Price>();
        }
        this.recurringPrice.add(recurringPriceItem);
        return this;
    }

    public List<Price> getRecurringPrice() {
        return recurringPrice;
    }

    public Tier setBlocks(final List<TieredBlock> blocks) {
        this.blocks = blocks;
        return this;
    }

    public Tier addBlocksItem(final TieredBlock blocksItem) {
        if (this.blocks == null) {
            this.blocks = new ArrayList<TieredBlock>();
        }
        this.blocks.add(blocksItem);
        return this;
    }

    public List<TieredBlock> getBlocks() {
        return blocks;
    }

    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        Tier tier = (Tier) o;
        return Objects.equals(this.limits, tier.limits) &&
            Objects.equals(this.fixedPrice, tier.fixedPrice) &&
            Objects.equals(this.recurringPrice, tier.recurringPrice) &&
            Objects.equals(this.blocks, tier.blocks);
    }

    @Override
    public int hashCode() {
        return Objects.hash(limits,
            fixedPrice,
            recurringPrice,
            blocks);
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class Tier {\n");
        
        sb.append("    limits: ").append(toIndentedString(limits)).append("\n");
        sb.append("    fixedPrice: ").append(toIndentedString(fixedPrice)).append("\n");
        sb.append("    recurringPrice: ").append(toIndentedString(recurringPrice)).append("\n");
        sb.append("    blocks: ").append(toIndentedString(blocks)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }
}

